=begin
#OSDN REST API v0 beta

#OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.jp/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.jp/projects/osdn-codes/releases/p14859 . 

OpenAPI spec version: 0.0.20160304
Contact: admin@osdn.jp
Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module OSDNClient
  class ProjectApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param group_id group_id the news created in
    # @param [Hash] opts the optional parameters
    # @return [String]
    def create_news(title, body, group_id, opts = {})
      data, _status_code, _headers = create_news_with_http_info(title, body, group_id, opts)
      return data
    end

    # 
    # 
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param group_id group_id the news created in
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def create_news_with_http_info(title, body, group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_news ..."
      end
      # verify the required parameter 'title' is set
      fail ArgumentError, "Missing the required parameter 'title' when calling ProjectApi.create_news" if title.nil?
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling ProjectApi.create_news" if body.nil?
      # verify the required parameter 'group_id' is set
      fail ArgumentError, "Missing the required parameter 'group_id' when calling ProjectApi.create_news" if group_id.nil?
      # resource path
      local_var_path = "/news".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'group_id'] = group_id

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = title
      form_params["body"] = body

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param [Hash] opts the optional parameters
    # @return [String]
    def create_news_0(id_or_name, title, body, opts = {})
      data, _status_code, _headers = create_news_0_with_http_info(id_or_name, title, body, opts)
      return data
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param title news title
    # @param body news body in OSDN Wiki format.
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def create_news_0_with_http_info(id_or_name, title, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_news_0" if id_or_name.nil?
      # verify the required parameter 'title' is set
      fail ArgumentError, "Missing the required parameter 'title' when calling ProjectApi.create_news_0" if title.nil?
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling ProjectApi.create_news_0" if body.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = title
      form_params["body"] = body

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create a package.
    # @param id_or_name numeric project id or project name
    # @param name package name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Package]
    def create_package(id_or_name, name, opts = {})
      data, _status_code, _headers = create_package_with_http_info(id_or_name, name, opts)
      return data
    end

    # 
    # Create a package.
    # @param id_or_name numeric project id or project name
    # @param name package name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(Package, Fixnum, Hash)>] Package data, response status code and response headers
    def create_package_with_http_info(id_or_name, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_package" if id_or_name.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_package" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Package')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new release in specified package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param name Release name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [String] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [String] :release_note Release note body text.
    # @option opts [String] :change_log Changelog body text.
    # @return [Release]
    def create_release(id_or_name, package_id, name, opts = {})
      data, _status_code, _headers = create_release_with_http_info(id_or_name, package_id, name, opts)
      return data
    end

    # 
    # Create new release in specified package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param name Release name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [String] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [String] :release_note Release note body text.
    # @option opts [String] :change_log Changelog body text.
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def create_release_with_http_info(id_or_name, package_id, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.create_release" if package_id.nil?
      # verify the required parameter 'name' is set
      fail ArgumentError, "Missing the required parameter 'name' when calling ProjectApi.create_release" if name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = name
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?
      form_params["time"] = opts[:'time'] if !opts[:'time'].nil?
      form_params["release_note"] = opts[:'release_note'] if !opts[:'release_note'].nil?
      form_params["change_log"] = opts[:'change_log'] if !opts[:'change_log'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Create new file in target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file Upload file in \&quot;multipart/form-data\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [RelFile]
    def create_release_file(id_or_name, package_id, release_id, file, opts = {})
      data, _status_code, _headers = create_release_file_with_http_info(id_or_name, package_id, release_id, file, opts)
      return data
    end

    # 
    # Create new file in target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file Upload file in \&quot;multipart/form-data\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(RelFile, Fixnum, Hash)>] RelFile data, response status code and response headers
    def create_release_file_with_http_info(id_or_name, package_id, release_id, file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.create_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.create_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.create_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.create_release_file" if release_id.nil?
      # verify the required parameter 'file' is set
      fail ArgumentError, "Missing the required parameter 'file' when calling ProjectApi.create_release_file" if file.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['multipart/form-data']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["file"] = file
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RelFile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#create_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_news(news_id, opts = {})
      delete_news_with_http_info(news_id, opts)
      return nil
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_news_with_http_info(news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_news ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.delete_news" if news_id.nil?
      # resource path
      local_var_path = "/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_news_0(id_or_name, news_id, opts = {})
      delete_news_0_with_http_info(id_or_name, news_id, opts)
      return nil
    end

    # 
    # 
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_news_0_with_http_info(id_or_name, news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_news_0" if id_or_name.nil?
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.delete_news_0" if news_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news/{news_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete taret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_package(id_or_name, package_id, opts = {})
      delete_package_with_http_info(id_or_name, package_id, opts)
      return nil
    end

    # 
    # Delete taret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_package_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_package" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.delete_package" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_release(id_or_name, package_id, release_id, opts = {})
      delete_release_with_http_info(id_or_name, package_id, release_id, opts)
      return nil
    end

    # 
    # Delete target release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_release_with_http_info(id_or_name, package_id, release_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.delete_release" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.delete_release" if release_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Delete target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_release_file(id_or_name, package_id, release_id, file_id, opts = {})
      delete_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts)
      return nil
    end

    # 
    # Delete target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.delete_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.delete_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.delete_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.delete_release_file" if release_id.nil?
      # verify the required parameter 'file_id' is set
      fail ArgumentError, "Missing the required parameter 'file_id' when calling ProjectApi.delete_release_file" if file_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s).sub('{' + 'file_id' + '}', file_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#delete_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get release draft in specified package. If draft is not exist, it will be created automatically.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Release]
    def draft_release(id_or_name, package_id, opts = {})
      data, _status_code, _headers = draft_release_with_http_info(id_or_name, package_id, opts)
      return data
    end

    # 
    # Get release draft in specified package. If draft is not exist, it will be created automatically.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def draft_release_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.draft_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.draft_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.draft_release" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/draft".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#draft_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get single news object.
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [News]
    def get_news(news_id, opts = {})
      data, _status_code, _headers = get_news_with_http_info(news_id, opts)
      return data
    end

    # 
    # Get single news object.
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def get_news_with_http_info(news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_news ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.get_news" if news_id.nil?
      # resource path
      local_var_path = "/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get single news object.
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [News]
    def get_news_0(id_or_name, news_id, opts = {})
      data, _status_code, _headers = get_news_0_with_http_info(id_or_name, news_id, opts)
      return data
    end

    # 
    # Get single news object.
    # @param id_or_name numeric project id or project name
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def get_news_0_with_http_info(id_or_name, news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_news_0" if id_or_name.nil?
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.get_news_0" if news_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news/{news_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get specified package info and release list of the package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Package]
    def get_package(id_or_name, package_id, opts = {})
      data, _status_code, _headers = get_package_with_http_info(id_or_name, package_id, opts)
      return data
    end

    # 
    # Get specified package info and release list of the package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Package, Fixnum, Hash)>] Package data, response status code and response headers
    def get_package_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_package" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.get_package" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Package')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get project info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Group]
    def get_project(id_or_name, opts = {})
      data, _status_code, _headers = get_project_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get project info.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Group, Fixnum, Hash)>] Group data, response status code and response headers
    def get_project_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_project ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_project" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Group')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_project\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get specified release info and file list of the release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [Release]
    def get_release(id_or_name, package_id, release_id, opts = {})
      data, _status_code, _headers = get_release_with_http_info(id_or_name, package_id, release_id, opts)
      return data
    end

    # 
    # Get specified release info and file list of the release.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def get_release_with_http_info(id_or_name, package_id, release_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.get_release" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.get_release" if release_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get single file object.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [RelFile]
    def get_release_file(id_or_name, package_id, release_id, file_id, opts = {})
      data, _status_code, _headers = get_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts)
      return data
    end

    # 
    # Get single file object.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RelFile, Fixnum, Hash)>] RelFile data, response status code and response headers
    def get_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.get_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.get_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.get_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.get_release_file" if release_id.nil?
      # verify the required parameter 'file_id' is set
      fail ArgumentError, "Missing the required parameter 'file_id' when calling ProjectApi.get_release_file" if file_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s).sub('{' + 'file_id' + '}', file_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RelFile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#get_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :group_id filter by group ID
    # @return [Array<News>]
    def list_news(opts = {})
      data, _status_code, _headers = list_news_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :group_id filter by group ID
    # @return [Array<(Array<News>, Fixnum, Hash)>] Array<News> data, response status code and response headers
    def list_news_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_news ..."
      end
      # resource path
      local_var_path = "/news".sub('{format}','json')

      # query parameters
      query_params = {}
      query_params[:'group_id'] = opts[:'group_id'] if !opts[:'group_id'].nil?

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<News>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get news list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<News>]
    def list_news_0(id_or_name, opts = {})
      data, _status_code, _headers = list_news_0_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get news list of spscified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<News>, Fixnum, Hash)>] Array<News> data, response status code and response headers
    def list_news_0_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_news_0 ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_news_0" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<News>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Get package list of specified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<Package>]
    def list_packages(id_or_name, opts = {})
      data, _status_code, _headers = list_packages_with_http_info(id_or_name, opts)
      return data
    end

    # 
    # Get package list of specified project.
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Package>, Fixnum, Hash)>] Array<Package> data, response status code and response headers
    def list_packages_with_http_info(id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.list_packages ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.list_packages" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Package>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#list_packages\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [News]
    def update_news(news_id, opts = {})
      data, _status_code, _headers = update_news_with_http_info(news_id, opts)
      return data
    end

    # 
    # 
    # @param news_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def update_news_with_http_info(news_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_news ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.update_news" if news_id.nil?
      # resource path
      local_var_path = "/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = opts[:'title'] if !opts[:'title'].nil?
      form_params["body"] = opts[:'body'] if !opts[:'body'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_news\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param news_id 
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [News]
    def update_news_0(news_id, id_or_name, opts = {})
      data, _status_code, _headers = update_news_0_with_http_info(news_id, id_or_name, opts)
      return data
    end

    # 
    # 
    # @param news_id 
    # @param id_or_name numeric project id or project name
    # @param [Hash] opts the optional parameters
    # @option opts [String] :title news title
    # @option opts [String] :body news body in OSDN Wiki format.
    # @return [Array<(News, Fixnum, Hash)>] News data, response status code and response headers
    def update_news_0_with_http_info(news_id, id_or_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_news_0 ..."
      end
      # verify the required parameter 'news_id' is set
      fail ArgumentError, "Missing the required parameter 'news_id' when calling ProjectApi.update_news_0" if news_id.nil?
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_news_0" if id_or_name.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/news/{news_id}".sub('{format}','json').sub('{' + 'news_id' + '}', news_id.to_s).sub('{' + 'id_or_name' + '}', id_or_name.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["title"] = opts[:'title'] if !opts[:'title'].nil?
      form_params["body"] = opts[:'body'] if !opts[:'body'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'News')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_news_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update tagret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name package name
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Package]
    def update_package(id_or_name, package_id, opts = {})
      data, _status_code, _headers = update_package_with_http_info(id_or_name, package_id, opts)
      return data
    end

    # 
    # Update tagret package.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name package name
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(Package, Fixnum, Hash)>] Package data, response status code and response headers
    def update_package_with_http_info(id_or_name, package_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_package ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_package" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.update_package" if package_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Package')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_package\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Update target release. (Note: If you update draft release, the release will be public automatically.) 
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [String] :name Release name
    # @option opts [String] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [Integer] :move_to_package_id If this parameter is specified, the release move to another package.
    # @return [Release]
    def update_release(id_or_name, package_id, release_id, opts = {})
      data, _status_code, _headers = update_release_with_http_info(id_or_name, package_id, release_id, opts)
      return data
    end

    # 
    # Update target release. (Note: If you update draft release, the release will be public automatically.) 
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @option opts [String] :name Release name
    # @option opts [String] :time Release datetime. If you set future time, the release hide until specified time.
    # @option opts [Integer] :move_to_package_id If this parameter is specified, the release move to another package.
    # @return [Array<(Release, Fixnum, Hash)>] Release data, response status code and response headers
    def update_release_with_http_info(id_or_name, package_id, release_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_release ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_release" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.update_release" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.update_release" if release_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?
      form_params["name"] = opts[:'name'] if !opts[:'name'].nil?
      form_params["time"] = opts[:'time'] if !opts[:'time'].nil?
      form_params["move_to_package_id"] = opts[:'move_to_package_id'] if !opts[:'move_to_package_id'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Release')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_release\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Change visibility of target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [RelFile]
    def update_release_file(id_or_name, package_id, release_id, file_id, opts = {})
      data, _status_code, _headers = update_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts)
      return data
    end

    # 
    # Change visibility of target file.
    # @param id_or_name numeric project id or project name
    # @param package_id 
    # @param release_id 
    # @param file_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :visibility visibility status (public, hidden or private)
    # @return [Array<(RelFile, Fixnum, Hash)>] RelFile data, response status code and response headers
    def update_release_file_with_http_info(id_or_name, package_id, release_id, file_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: ProjectApi.update_release_file ..."
      end
      # verify the required parameter 'id_or_name' is set
      fail ArgumentError, "Missing the required parameter 'id_or_name' when calling ProjectApi.update_release_file" if id_or_name.nil?
      # verify the required parameter 'package_id' is set
      fail ArgumentError, "Missing the required parameter 'package_id' when calling ProjectApi.update_release_file" if package_id.nil?
      # verify the required parameter 'release_id' is set
      fail ArgumentError, "Missing the required parameter 'release_id' when calling ProjectApi.update_release_file" if release_id.nil?
      # verify the required parameter 'file_id' is set
      fail ArgumentError, "Missing the required parameter 'file_id' when calling ProjectApi.update_release_file" if file_id.nil?
      # resource path
      local_var_path = "/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}".sub('{format}','json').sub('{' + 'id_or_name' + '}', id_or_name.to_s).sub('{' + 'package_id' + '}', package_id.to_s).sub('{' + 'release_id' + '}', release_id.to_s).sub('{' + 'file_id' + '}', file_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = []
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/x-www-form-urlencoded']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}
      form_params["visibility"] = opts[:'visibility'] if !opts[:'visibility'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['oauth2-code', 'oauth2-implicit']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RelFile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ProjectApi#update_release_file\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
